- name: Configure primary app servers for Omnibus environments
  block:
    - name: Primary App Servers - Add new config
      template:
        src: templates/primary-app-servers.rb.j2
        dest: /etc/gitlab/gitlab.geo.primary-app-servers.rb

    - name: Primary App Servers - Run gitlab-ctl reconfigure
      command: gitlab-ctl reconfigure

    - name: Primary App Servers - Set geo primary node
      command: gitlab-ctl set-geo-primary-node
      when: ('gitlab_rails_primary' in group_names)

    - name: Primary App Servers - Update internal URL for primary site
      command: |
        gitlab-rails runner "GeoNode.find_by(name: '{{ geo_primary_site_name }}').update(internal_url: '{{ geo_primary_internal_url }}')"
      when: ('gitlab_rails_primary' in group_names)
  when:
    - ('gitlab_rails' in group_names or 'sidekiq' in group_names)
    - (geo_primary_site_group_name in group_names)

- name: Configure primary app servers for Cloud Native Hybrid environments
  block:
    - name: Primary App Servers - Configure kubeconfig credentials for Geo primary site
      become: false
      delegate_to: localhost
      run_once: true
      import_tasks: kubeconfig.yml
      vars:
        geo_site_prefix: "{{ geo_primary_site_prefix }}"
        geo_site_gcp_project: "{{ geo_primary_site_gcp_project }}"
        geo_site_gcp_gke_location: "{{ geo_primary_site_gcp_gke_location }}"
        geo_site_aws_region: "{{ geo_primary_site_aws_region }}"

    - name: Primary App Servers - Set Primary site
      become: false
      delegate_to: localhost
      run_once: true
      register: result
      kubernetes.core.k8s_exec:
        pod: "{{ toolbox_pod }}"
        namespace: "{{ gitlab_charts_release_namespace }}"
        command: gitlab-rake geo:set_primary_node
      failed_when:
        - result.rc == 1
        - ("GitLab Geo primary node already present" not in result.stderr)

    - name: Primary App Servers - Update internal URL for primary site
      become: false
      delegate_to: localhost
      run_once: true
      kubernetes.core.k8s_exec:
        pod: "{{ toolbox_pod }}"
        namespace: "{{ gitlab_charts_release_namespace }}"
        command: |
          gitlab-rails runner "GeoNode.find_by(name: '{{ geo_primary_site_name }}').update(internal_url: '{{ geo_primary_internal_url }}')"
  when: cloud_native_hybrid_geo
